rm(list=ls(all=TRUE))

# set working directory with setwd()

# Number of observations
n <- 1000     # 100, 250, 500, 1000

# Number of Replications
Q <- 1000

# Burn-in-period
B <- 200

# Data Matrix
Y <- matrix(NA, nrow=n, ncol=Q)

# Threshold parameter (two regime models)
c <- 0

# Threshold parameters (three regime SETAR models)
c1 <- -0.5  # 5 for SETAR(2,2,2)
c2 <- 0.5   # 12 for SETAR(2,2,2)

# Delay parameter
d <- 1 # 2 for SETAR(2,2,2)

# Transition Variable
gamma <- 1  #20

### estimated model order
 p.max<-4

set.seed(123)


for(q in 1:Q){

# error terms
u <- rnorm(n+B+p.max,mean=0,sd=1)

y <- numeric(n+B+p.max)
for(i in (p.max+1):(n+B+p.max)){
 # AR(1)
 #y[i] <- 0.5*y[i-1]+u[i]
 # AR(2)
 #y[i] <- -1.2 + 0.7*y[i-1] +  0.3*y[i-2]+u[i]
 # AR (3)
 #y[i] <- 1.2*y[i-1]-0.35*y[i-2]-0.1*y[i-3]+u[i]
 
 # TAR(1,1)
 #if(y[i-d] > c){y[i] <- 0.8*y[i-1]+u[i]}else{y[i] <- 0.2*y[i-1]+u[i]}
 # TAR(1,3)
 #if(y[i-d] > c){y[i] <- 0.2*y[i-1]+u[i]}else{y[i] <- 1.2*y[i-1]-0.35*y[i-2]-0.1*y[i-3]+u[i]}
 # TAR(2,1)
 #if(y[i-d] > c){y[i] <- 1+0.7*y[i-1]-0.3*y[i-2]+u[i]}else{y[i] <- 0.8*y[i-1]+u[i]}
 # TAR(2,2)
 #if(y[i-d] > c){y[i] <- 1.2+0.7*y[i-1]-0.2*y[i-2]+u[i]}else{y[i] <- 1-1.1*y[i-1]+0.18*y[i-2]+u[i]}
 #TAR(2,3)
 #if(y[i-d] > c){y[i] <- 1.2+0.7*y[i-1]-0.2*y[i-2]+u[i]}else{y[i] <- 1.2*y[i-1]-0.35*y[i-2]-0.1*y[i-3]+u[i]}
 #TAR(3,2)
 #if(y[i-d] > c){y[i] <- 1.2*y[i-1]-0.35*y[i-2]-0.1*y[i-3]+u[i]}else{y[i] <- 1.2+0.7*y[i-1]-0.2*y[i-2]+u[i]}
 # TAR(4,3)
 #if(y[i-d] > c){y[i] <- -1.0499*y[i-1]+2.6535*y[i-3]-0.9238*y[i-4]+u[i]}else{y[i]<-1.2*y[i-1]-0.35*y[i-2]-0.1*y[i-3]+u[i]}
 
# TAR(1,1,1)
 #if(y[i-d] > c2){ y[i] <- -0.5*y[i-1]+u[i]
 #}else{
 #if(y[i-d] < c1){ y[i] <- 0.2*y[i-1]+u[i]
 #}else{ y[i] <- 0.8*y[i-1]+u[i]
 #} }
 # TAR(2,2,2)
 #if(y[i-d] > c2){ y[i] <- 1+0.7*y[i-1]-0.3*y[i-2]+u[i]
 #}else{
 #if(y[i-d] < c1){ y[i] <- 2.7+0.8*y[i-1]-0.2*y[i-2]+u[i]
 #}else{ y[i] <- 6+1.9*y[i-1]-1.2*y[i-2]+u[i]
 #} }
  
 #LSTAR(1,1)
 #Ft <- 1/(1+exp(-gamma*(y[i-d]-c)))
 #y[i] <- (0.8*y[i-1])*(1-Ft)+(0.2*y[i-1])*Ft+u[i]
 #LSTAR(2,2)
 #Ft <- 1/(1+exp(-gamma*(y[i-d]-c)))
 #y[i] <- (1.8*y[i-1]-1.06*y[i-2])*(1-Ft)+(0.02+0.9*y[i-1]-0.265*y[i-2])*Ft+u[i]
 #LSTAR(3,4)
 #Ft <- 1/(1+exp(-gamma*(y[i-d]-c)))
 #y[i] <- (1.8*y[i-1]-1.06*y[i-2]-0.2*y[i-3])*(1-Ft)+(0.02+0.9*y[i-1]-0.265*y[i-2]+0.27*y[i-3]-0.32*y[i-4])*Ft+u[i]
 
 #ESTAR(1,1)
 Ft <- 1-exp(-gamma*(y[i-d]-c)^2)
 y[i] <- (0.8*y[i-1])*(1-Ft)+(0.2*y[i-1])*Ft+u[i]
 #ESTAR(2,2)
 #Ft <- 1-exp(-gamma*(y[i-d]-c)^2)
 #y[i] <- (1.8*y[i-1]-1.06*y[i-2])*(1-Ft)+(0.02+0.9*y[i-1]-0.265*y[i-2])*Ft+u[i]
 #ESTAR(3,4)
 #Ft <- 1-exp(-gamma*(y[i-d]-c)^2)
 #y[i] <- (1.8*y[i-1]-1.06*y[i-2]-0.2*y[i-3])*(1-Ft)+(0.02+0.9*y[i-1]-0.265*y[i-2]+0.27*y[i-3]-0.32*y[i-4])*Ft+u[i]
 }

# Eliminate Burn-in period
y <- y[(B+1):(B+n)]


Y[,q]<-y
}

write.table(Y,"ESTAR(1,1)gamma1.txt")












