rm(list=ls(all=TRUE))
library(xtable)
# set working directory with setwd()

# read the previously calculated information criteria
#here: DGP AR(1) with n=250, all model classes fitted to that process
# if you are not interested in some model class, do not read the corresponding tables and do some slight changes below

AR1 <-read.table("IC.250.AR(1).AR1.xls",sep = '\t')
AR2 <-read.table("IC.250.AR(1).AR2.xls",sep = '\t')
AR3 <-read.table("IC.250.AR(1).AR3.xls",sep = '\t')
AR4 <-read.table("IC.250.AR(1).AR4.xls",sep = '\t')

TAR1 <-read.table("IC.250.AR(1).TAR1.xls",sep = '\t')
TAR2 <-read.table("IC.250.AR(1).TAR2.xls",sep = '\t')
TAR3 <-read.table("IC.250.AR(1).TAR3.xls",sep = '\t')
TAR4 <-read.table("IC.250.AR(1).TAR4.xls",sep = '\t')

TAR5 <-read.table("IC.250.AR(1).TAR5.xls",sep = '\t')
TAR6 <-read.table("IC.250.AR(1).TAR6.xls",sep = '\t')
TAR7 <-read.table("IC.250.AR(1).TAR7.xls",sep = '\t')
TAR8 <-read.table("IC.250.AR(1).TAR8.xls",sep = '\t')

TAR9 <-read.table("IC.250.AR(1).TAR9.xls",sep = '\t')
TAR10 <-read.table("IC.250.AR(1).TAR10.xls",sep = '\t')
TAR11 <-read.table("IC.250.AR(1).TAR11.xls",sep = '\t')
TAR12 <-read.table("IC.250.AR(1).TAR12.xls",sep = '\t')

TAR13 <-read.table("IC.250.AR(1).TAR13.xls",sep = '\t')
TAR14 <-read.table("IC.250.AR(1).TAR14.xls",sep = '\t')
TAR15 <-read.table("IC.250.AR(1).TAR15.xls",sep = '\t')
TAR16 <-read.table("IC.250.AR(1).TAR16.xls",sep = '\t')

ESTAR1 <-read.table("IC.250.AR(1).ESTAR1.xls",sep = '\t')
ESTAR2 <-read.table("IC.250.AR(1).ESTAR2.xls",sep = '\t')
ESTAR3 <-read.table("IC.250.AR(1).ESTAR3.xls",sep = '\t')
ESTAR4 <-read.table("IC.250.AR(1).ESTAR4.xls",sep = '\t')

ESTAR5 <-read.table("IC.250.AR(1).ESTAR5.xls",sep = '\t')
ESTAR6 <-read.table("IC.250.AR(1).ESTAR6.xls",sep = '\t')
ESTAR7 <-read.table("IC.250.AR(1).ESTAR7.xls",sep = '\t')
ESTAR8 <-read.table("IC.250.AR(1).ESTAR8.xls",sep = '\t')

ESTAR9 <-read.table("IC.250.AR(1).ESTAR9.xls",sep = '\t')
ESTAR10 <-read.table("IC.250.AR(1).ESTAR10.xls",sep = '\t')
ESTAR11 <-read.table("IC.250.AR(1).ESTAR11.xls",sep = '\t')
ESTAR12 <-read.table("IC.250.AR(1).ESTAR12.xls",sep = '\t')

ESTAR13 <-read.table("IC.250.AR(1).ESTAR13.xls",sep = '\t')
ESTAR14 <-read.table("IC.250.AR(1).ESTAR14.xls",sep = '\t')
ESTAR15 <-read.table("IC.250.AR(1).ESTAR15.xls",sep = '\t')
ESTAR16 <-read.table("IC.250.AR(1).ESTAR16.xls",sep = '\t')

LSTAR1 <-read.table("IC.250.AR(1).LSTAR1.xls",sep = '\t')
LSTAR2 <-read.table("IC.250.AR(1).LSTAR2.xls",sep = '\t')
LSTAR3 <-read.table("IC.250.AR(1).LSTAR3.xls",sep = '\t')
LSTAR4 <-read.table("IC.250.AR(1).LSTAR4.xls",sep = '\t')

LSTAR5 <-read.table("IC.250.AR(1).LSTAR5.xls",sep = '\t')
LSTAR6 <-read.table("IC.250.AR(1).LSTAR6.xls",sep = '\t')
LSTAR7 <-read.table("IC.250.AR(1).LSTAR7.xls",sep = '\t')
LSTAR8 <-read.table("IC.250.AR(1).LSTAR8.xls",sep = '\t')

LSTAR9 <-read.table("IC.250.AR(1).LSTAR9.xls",sep = '\t')
LSTAR10 <-read.table("IC.250.AR(1).LSTAR10.xls",sep = '\t')
LSTAR11 <-read.table("IC.250.AR(1).LSTAR11.xls",sep = '\t')
LSTAR12 <-read.table("IC.250.AR(1).LSTAR12.xls",sep = '\t')

LSTAR13 <-read.table("IC.250.AR(1).LSTAR13.xls",sep = '\t')
LSTAR14 <-read.table("IC.250.AR(1).LSTAR14.xls",sep = '\t')
LSTAR15 <-read.table("IC.250.AR(1).LSTAR15.xls",sep = '\t')
LSTAR16 <-read.table("IC.250.AR(1).LSTAR16.xls",sep = '\t')


D <- matrix(NA,nrow=1000,ncol=24)  # row=replication, col=criterion

# choose for each citerion and each replication which model minimizes the respective criterion
# delete the model you are not interested in
for(q in 1:1000)
{
  freqs <- rbind(AR1[q,],AR2[q,],AR3[q,],AR4[q,],
  TAR1[q,],TAR2[q,],TAR3[q,],TAR4[q,],TAR5[q,],TAR6[q,],TAR7[q,],TAR8[q,],
  TAR9[q,],TAR10[q,],TAR11[q,],TAR12[q,],TAR13[q,],TAR14[q,],TAR15[q,],TAR16[q,],
  ESTAR1[q,],ESTAR2[q,],ESTAR3[q,],ESTAR4[q,],ESTAR5[q,],ESTAR6[q,],ESTAR7[q,],ESTAR8[q,],
  ESTAR9[q,],ESTAR10[q,],ESTAR11[q,],ESTAR12[q,],ESTAR13[q,],ESTAR14[q,],ESTAR15[q,],ESTAR16[q,],
  LSTAR1[q,],LSTAR2[q,],  LSTAR3[q,],LSTAR4[q,],LSTAR5[q,],LSTAR6[q,],LSTAR7[q,],LSTAR8[q,],
  LSTAR9[q,],LSTAR10[q,],LSTAR11[q,],LSTAR12[q,],LSTAR13[q,],LSTAR14[q,],  LSTAR15[q,],LSTAR16[q,])
  
  for(m in 1:24)
  {
    D[q,m] <- which.min(freqs[,m])
  }
  print(q)
}

#calculate selection frequencies
p.freqs <- array(NA, c(52,8,3)) # row= model, col= criterion(AIC, SIC,...,hat sigma, tilde sigma), matrix= version (regime, equally, overall)                       # 52= 4 AR + 16 SETAR + 16 ESTAR + 16 LSTAR
for(m in 1:8){
for(a in 1:3){
p.freqs[1,m,a] <- sum(D[,(m+8*(a-1))]==1)
p.freqs[2,m,a] <- sum(D[,(m+8*(a-1))]==2)
p.freqs[3,m,a] <- sum(D[,(m+8*(a-1))]==3)
p.freqs[4,m,a] <- sum(D[,(m+8*(a-1))]==4)
p.freqs[5,m,a] <- sum(D[,(m+8*(a-1))]==5)
p.freqs[6,m,a] <- sum(D[,(m+8*(a-1))]==6)
p.freqs[7,m,a] <- sum(D[,(m+8*(a-1))]==7)
p.freqs[8,m,a] <- sum(D[,(m+8*(a-1))]==8)
p.freqs[9,m,a] <- sum(D[,(m+8*(a-1))]==9)
p.freqs[10,m,a] <- sum(D[,(m+8*(a-1))]==10)
p.freqs[11,m,a] <- sum(D[,(m+8*(a-1))]==11)
p.freqs[12,m,a] <- sum(D[,(m+8*(a-1))]==12)
p.freqs[13,m,a] <- sum(D[,(m+8*(a-1))]==13)
p.freqs[14,m,a] <- sum(D[,(m+8*(a-1))]==14)
p.freqs[15,m,a] <- sum(D[,(m+8*(a-1))]==15)
p.freqs[16,m,a] <- sum(D[,(m+8*(a-1))]==16)
p.freqs[17,m,a] <- sum(D[,(m+8*(a-1))]==17)
p.freqs[18,m,a] <- sum(D[,(m+8*(a-1))]==18)
p.freqs[19,m,a] <- sum(D[,(m+8*(a-1))]==19)
p.freqs[20,m,a] <- sum(D[,(m+8*(a-1))]==20)
p.freqs[21,m,a] <- sum(D[,(m+8*(a-1))]==21)
p.freqs[22,m,a] <- sum(D[,(m+8*(a-1))]==22)
p.freqs[23,m,a] <- sum(D[,(m+8*(a-1))]==23)
p.freqs[24,m,a] <- sum(D[,(m+8*(a-1))]==24)
p.freqs[25,m,a] <- sum(D[,(m+8*(a-1))]==25)
p.freqs[26,m,a] <- sum(D[,(m+8*(a-1))]==26)
p.freqs[27,m,a] <- sum(D[,(m+8*(a-1))]==27)
p.freqs[28,m,a] <- sum(D[,(m+8*(a-1))]==28)
p.freqs[29,m,a] <- sum(D[,(m+8*(a-1))]==29)
p.freqs[30,m,a] <- sum(D[,(m+8*(a-1))]==30)
p.freqs[31,m,a] <- sum(D[,(m+8*(a-1))]==31)
p.freqs[32,m,a] <- sum(D[,(m+8*(a-1))]==32)
p.freqs[33,m,a] <- sum(D[,(m+8*(a-1))]==33)
p.freqs[34,m,a] <- sum(D[,(m+8*(a-1))]==34)
p.freqs[35,m,a] <- sum(D[,(m+8*(a-1))]==35)
p.freqs[36,m,a] <- sum(D[,(m+8*(a-1))]==36)
p.freqs[37,m,a] <- sum(D[,(m+8*(a-1))]==37)
p.freqs[38,m,a] <- sum(D[,(m+8*(a-1))]==38)
p.freqs[39,m,a] <- sum(D[,(m+8*(a-1))]==39)
p.freqs[40,m,a] <- sum(D[,(m+8*(a-1))]==40)
p.freqs[41,m,a] <- sum(D[,(m+8*(a-1))]==41)
p.freqs[42,m,a] <- sum(D[,(m+8*(a-1))]==42)
p.freqs[43,m,a] <- sum(D[,(m+8*(a-1))]==43)
p.freqs[44,m,a] <- sum(D[,(m+8*(a-1))]==44)
p.freqs[45,m,a] <- sum(D[,(m+8*(a-1))]==45)
p.freqs[46,m,a] <- sum(D[,(m+8*(a-1))]==46)
p.freqs[47,m,a] <- sum(D[,(m+8*(a-1))]==47)
p.freqs[48,m,a] <- sum(D[,(m+8*(a-1))]==48)
p.freqs[49,m,a] <- sum(D[,(m+8*(a-1))]==49)
p.freqs[50,m,a] <- sum(D[,(m+8*(a-1))]==50)
p.freqs[51,m,a] <- sum(D[,(m+8*(a-1))]==51)
p.freqs[52,m,a] <- sum(D[,(m+8*(a-1))]==52)
}
}

p.freqs <- p.freqs/1000

dimnames(p.freqs)<- list(c("AR1","AR2","AR3","AR4",
"TAR11","TAR12","TAR13","TAR14","TAR21","TAR22","TAR23","TAR24","TAR31","TAR32","TAR33","TAR34","TAR41","TAR42","TAR43","TAR44","ESTAR11","ESTAR12","ESTAR13","ESTAR14","ESTAR21","ESTAR22","ESTAR23","ESTAR24",
"ESTAR31","ESTAR32","ESTAR33","ESTAR34","ESTAR41","ESTAR42","ESTAR43","ESTAR44",
"LSTAR11","LSTAR12","LSTAR13","LSTAR14","LSTAR21","LSTAR22","LSTAR23","LSTAR24",
"LSTAR31","LSTAR32","LSTAR33","LSTAR34","LSTAR41","LSTAR42","LSTAR43","LSTAR44"),
c("AIC.ML","AIC.OLS","BIC.ML","BIC.OLS","AICc.ML","AICc.OLS","WIC.ML","WIC.OLS"),
c("regime","equally","overall"))

# tables that can be saved in excel (one for each version (regime, equally, overall))
excel <- cbind(p.freqs[,,1],p.freqs[,,2],p.freqs[,,3])

colnames(excel)<-c("AIC.ML","AIC.OLS","BIC.ML","BIC.OLS","AICc.ML","AICc.OLS","WIC.ML","WIC.OLS",
"AIC.eq.ML","AIC.eq.OLS","BIC.eq.ML","BIC.eq.OLS","AICc.eq.ML","AICc.eq.OLS","WIC.eq.ML","WIC.eq.OLS",
"AIC.ov.ML","AIC.ov.OLS","BIC.ov.ML","BIC.ov.OLS","AICc.ov.ML","AICc.ov.OLS","WIC.ov.ML","WIC.ov.OLS")


write.table(excel, "freq.all.250.AR(1).xls",sep='\t',col.names=TRUE, row.names=TRUE)

# for latex
for(i in 1:3)
{
 x <- xtable(p.freqs[rowSums(p.freqs[,,i])!=0,,i],digits=3)
 print(x)
}

Z<-array(NA,c(5,8,3))
for(j in 1:8){
for(k in 1:3){
Z[1,j,k] <- sum(p.freqs[1:4,j,k])     # AR frequency
Z[2,j,k] <- sum(p.freqs[5:20,j,k])    # SETAR 
Z[3,j,k] <- sum(p.freqs[21:36,j,k])   # ESTAR
Z[4,j,k] <- sum(p.freqs[37:52,j,k])   # LSTAR
Z[5,j,k] <- sum(Z[2:4,j,k])           # sum of selecting nonlinear model (size if the DGP is linear)
}
}

dimnames(Z)<- list(c("AR","TAR","ESTAR","LSTAR","size"),
c("AIC.ML","AIC.OLS","BIC.ML","BIC.OLS","AICc.ML","AICc.OLS","WIC.ML","WIC.OLS"),
c("regime","equally","overall"))

# for latex
for(i in 1:3)
{
 x <- xtable(Z[,,i],digits=3)
 print(x)
}

# save size in excel tables
Z.excel <- cbind(Z[,,1],Z[,,2],Z[,,3])
colnames(Z.excel) <- c("AIC.ML","AIC.OLS","BIC.ML","BIC.OLS","AICc.ML","AICc.OLS","WIC.ML","WIC.OLS",
"AIC.eq.ML","AIC.eq.OLS","BIC.eq.ML","BIC.eq.OLS","AICc.eq.ML","AICc.eq.OLS","WIC.eq.ML","WIC.eq.OLS",
"AIC.ov.ML","AIC.ov.OLS","BIC.ov.ML","BIC.ov.OLS","AICc.ov.ML","AICc.ov.OLS","WIC.ov.ML","WIC.ov.OLS")
rownames(Z.excel) <- c("AR","TAR","ESTAR","LSTAR","size")
write.table(Z.excel, "size.250.AR(1).xls",sep='\t',col.names=TRUE, row.names=TRUE)



