rm(list=ls(all=TRUE))
# set working directory with setwd()

# example: power for SETAR. True DGP is SETAR(1,3).
# read selection frequencies (only consider the correct model class! here only TAR models)
# read selection frequencies of nonlinear models for size (true DGP is linear)


TAR.100 <- read.table("n=100\\freq.TAR.100.TAR(1,3).xls",sep='\t')
TAR.250 <- read.table("n=250\\freq.TAR.250.TAR(1,3).xls",sep='\t')
TAR.500 <- read.table("n=500\\freq.TAR.500.TAR(1,3).xls",sep='\t')
TAR.1000 <- read.table("n=1000\\freq.TAR.1000.TAR(1,3).xls",sep='\t')

#true model TAR(1,3) -> power equals the frequency of selecting TAR(1,3) -> 3rd row

AIC.ML <- c(TAR.100[3,1],TAR.250[3,1],TAR.500[3,1],TAR.1000[3,1])
AIC.LS <- c(TAR.100[3,2],TAR.250[3,2],TAR.500[3,2],TAR.1000[3,2])
BIC.ML <- c(TAR.100[3,3],TAR.250[3,3],TAR.500[3,3],TAR.1000[3,3])
BIC.LS <- c(TAR.100[3,4],TAR.250[3,4],TAR.500[3,4],TAR.1000[3,4])
AICc.ML <- c(TAR.100[3,5],TAR.250[3,5],TAR.500[3,5],TAR.1000[3,5])
AICc.LS <- c(TAR.100[3,6],TAR.250[3,6],TAR.500[3,6],TAR.1000[3,6])
WIC.ML <- c(TAR.100[3,7],TAR.250[3,7],TAR.500[3,7],TAR.1000[3,7])
WIC.LS <- c(TAR.100[3,8],TAR.250[3,8],TAR.500[3,8],TAR.1000[3,8])

AIC.ML.eq <- c(TAR.100[3,9],TAR.250[3,9],TAR.500[3,9],TAR.1000[3,9])
AIC.LS.eq <- c(TAR.100[3,10],TAR.250[3,10],TAR.500[3,10],TAR.1000[3,10])
BIC.ML.eq <- c(TAR.100[3,11],TAR.250[3,11],TAR.500[3,11],TAR.1000[3,11])
BIC.LS.eq <- c(TAR.100[3,12],TAR.250[3,12],TAR.500[3,12],TAR.1000[3,12])
AICc.ML.eq <- c(TAR.100[3,13],TAR.250[3,13],TAR.500[3,13],TAR.1000[3,13])
AICc.LS.eq <- c(TAR.100[3,14],TAR.250[3,14],TAR.500[3,14],TAR.1000[3,14])
WIC.ML.eq <- c(TAR.100[3,15],TAR.250[3,15],TAR.500[3,15],TAR.1000[3,15])
WIC.LS.eq <- c(TAR.100[3,16],TAR.250[3,16],TAR.500[3,16],TAR.1000[3,16])

AIC.ML.ov <- c(TAR.100[3,17],TAR.250[3,17],TAR.500[3,17],TAR.1000[3,17])
AIC.LS.ov <- c(TAR.100[3,18],TAR.250[3,18],TAR.500[3,18],TAR.1000[3,18])
BIC.ML.ov <- c(TAR.100[3,19],TAR.250[3,19],TAR.500[3,19],TAR.1000[3,19])
BIC.LS.ov <- c(TAR.100[3,20],TAR.250[3,20],TAR.500[3,20],TAR.1000[3,20])
AICc.ML.ov <- c(TAR.100[3,21],TAR.250[3,21],TAR.500[3,21],TAR.1000[3,21])
AICc.LS.ov <- c(TAR.100[3,22],TAR.250[3,22],TAR.500[3,22],TAR.1000[3,22])
WIC.ML.ov <- c(TAR.100[3,23],TAR.250[3,23],TAR.500[3,23],TAR.1000[3,23])
WIC.LS.ov <- c(TAR.100[3,24],TAR.250[3,24],TAR.500[3,24],TAR.1000[3,24])

n <- c(100,250,500,1000)

plot(n,AIC.ML,type="l",xlab="Number of Observations",ylab="Power",main="Regime Weighted Criteria",ylim=c(min(AIC.ML,AIC.LS,BIC.ML,BIC.LS,AICc.ML,AICc.LS,WIC.ML,WIC.LS),1))
lines(n,AIC.LS, lwd=2)
lines(n,BIC.ML,lty=2)
lines(n,BIC.LS,lty=2,lwd=2)
lines(n,AICc.ML,lty=3)
lines(n,AICc.LS,lty=3,lwd=2)
lines(n,WIC.ML,lty=4)
lines(n,WIC.LS,lty=4,lwd=2)

plot(n,AIC.ML.eq,type="l",xlab="Number of Observations",ylab="Power",main="Equally Weighted Criteria",ylim=c(min(AIC.ML,AIC.LS,BIC.ML,BIC.LS,AICc.ML,AICc.LS,WIC.ML,WIC.LS),1))
lines(n,AIC.LS.eq, lwd=2)
lines(n,BIC.ML.eq,lty=2)
lines(n,BIC.LS.eq,lty=2,lwd=2)
lines(n,AICc.ML.eq,lty=3)
lines(n,AICc.LS.eq,lty=3,lwd=2)
lines(n,WIC.ML.eq,lty=4)
lines(n,WIC.LS.eq,lty=4,lwd=2)

plot(n,AIC.ML.ov,type="l",xlab="Number of Observations",ylab="Power",main="Overall Criteria",ylim=c(0,1))#c(min(AIC.ML,AIC.LS,BIC.ML,BIC.LS,AICc.ML,AICc.LS,WIC.ML,WIC.LS),1))
lines(n,AIC.LS.ov, lwd=2)
lines(n,BIC.ML.ov,lty=2)
lines(n,BIC.LS.ov,lty=2,lwd=2)
lines(n,AICc.ML.ov,lty=3)
lines(n,AICc.LS.ov,lty=3,lwd=2)
lines(n,WIC.ML.ov,lty=4)
lines(n,WIC.LS.ov,lty=4,lwd=2)



legend(x=100,y=1,c(expression(AIC[hat(sigma)]),expression(AIC[tilde(sigma)]),expression(SIC[hat(sigma)]),expression(SIC[tilde(sigma)])),lty=c(1,1,2,2),lwd=c(1,2,1,2),bty="n")

legend(x=300,y=1,c(expression(AICc[hat(sigma)]),expression(AICc[tilde(sigma)]),expression(WICs[hat(sigma)]),expression(WICs[tilde(sigma)])),lty=c(3,3,4,4),lwd=c(1,2,1,2),bty="n")


