rm(list=ls(all=TRUE))
# set working directory with setwd()
                                                                 
# read selection frequencies of one model class with varying thresholds
# here: SETAR(2,1) with thresholds 0, 0.25, 0.5, 0.75, 1

TAR.100c0 <- read.table("freq.TAR.100.TAR(2,1)c0.xls",sep='\t')
TAR.250c0 <- read.table("freq.TAR.250.TAR(2,1)c0.xls",sep='\t')
TAR.500c0 <- read.table("freq.TAR.500.TAR(2,1)c0.xls",sep='\t')
TAR.1000c0 <- read.table("freq.TAR.1000.TAR(2,1)c0.xls",sep='\t')

TAR.100c05 <- read.table("freq.TAR.100.TAR(2,1)c05.xls",sep='\t')
TAR.250c05 <- read.table("freq.TAR.250.TAR(2,1)c05.xls",sep='\t')
TAR.500c05 <- read.table("freq.TAR.500.TAR(2,1)c05.xls",sep='\t')
TAR.1000c05 <- read.table("freq.TAR.1000.TAR(2,1)c05.xls",sep='\t')

TAR.100c1 <- read.table("freq.TAR.100.TAR(2,1)c1.xls",sep='\t')
TAR.250c1 <- read.table("freq.TAR.250.TAR(2,1)c1.xls",sep='\t')
TAR.500c1 <- read.table("freq.TAR.500.TAR(2,1)c1.xls",sep='\t')
TAR.1000c1 <- read.table("freq.TAR.1000.TAR(2,1)c1.xls",sep='\t')

TAR.100c075 <- read.table("freq.TAR.100.TAR(2,1)c075.xls",sep='\t')
TAR.250c075 <- read.table("freq.TAR.250.TAR(2,1)c075.xls",sep='\t')
TAR.500c075 <- read.table("freq.TAR.500.TAR(2,1)c075.xls",sep='\t')
TAR.1000c075 <- read.table("freq.TAR.1000.TAR(2,1)c075.xls",sep='\t')

TAR.100c025 <- read.table("freq.TAR.100.TAR(2,1)c025.xls",sep='\t')
TAR.250c025 <- read.table("freq.TAR.250.TAR(2,1)c025.xls",sep='\t')
TAR.500c025 <- read.table("freq.TAR.500.TAR(2,1)c025.xls",sep='\t')
TAR.1000c025 <- read.table("freq.TAR.1000.TAR(2,1)c025.xls",sep='\t')

################################################################################

#selection frequencies of correct model for varying thresholds and each criterion
# column 1: regime AIC, hat sigma  2: regime AIC, tilde sigma
# column 3: regime SIC, hat sigma  4: regime SIC, tilde sigma
# column 5: regime AICc, hat sigma 6: regime AICc, tilde sigma
# column 7: regime WIC, hat sigma  8: regime WIC, tilde sigma
# column 9 - 16: equally weighted IC
# column 17- 24: overall IC

#true model TAR(2,1) -> selection frequency of TAR(2,1) in 5th row

AIC.LSc0 <- c(TAR.100c0[5,2],TAR.250c0[5,2],TAR.500c0[5,2],TAR.1000c0[5,2])
AIC.LSc05 <- c(TAR.100c05[5,2],TAR.250c05[5,2],TAR.500c05[5,2],TAR.1000c05[5,2])
AIC.LSc1 <- c(TAR.100c1[5,2],TAR.250c1[5,2],TAR.500c1[5,2],TAR.1000c1[5,2])
AIC.LSc075 <- c(TAR.100c075[5,2],TAR.250c075[5,2],TAR.500c075[5,2],TAR.1000c075[5,2])
AIC.LSc025 <- c(TAR.100c025[5,2],TAR.250c025[5,2],TAR.500c025[5,2],TAR.1000c025[5,2])


AIC.LS <- cbind(AIC.LSc1,AIC.LSc025,AIC.LSc0,AIC.LSc075,AIC.LSc05)

n <- c(100,250,500,1000)

plot(n,AIC.LS[,1],type="l",xlab="Number of Observations",ylab="Power",main="Powr of regime weighted AIC with unbiased estimator",
ylim=c(min(AIC.LS),1),lwd=2)
lines(n, AIC.LS[,2], lty=4,lwd=2)
lines(n, AIC.LS[,3], lty=3,lwd=2)
lines(n, AIC.LS[,4], lty=2,lwd=2)
lines(n, AIC.LS[,5], lty=5,lwd=2)
legend(x=100, y=1, c("38%", "48%", "58%", "68%", "77%"), lty=c(1,2,5,4,3), lwd=2, bty="n")




